#include <iostream.h>
#include <stdio.h>
#include "mpi.h"

#define N 10

void main (int argc, char *argv[])
{
	MPI_Init( &argc, &argv );
	int rank=-1;
	int size=-1;
	int Iter = 100000;

MPI_Comm_size( MPI_COMM_WORLD, &size );
cout<<"Number of processors : "<<size<<endl;

MPI_Comm_rank( MPI_COMM_WORLD, &rank );
cout<<"My Rank: "<<rank<<endl;

MPI_Barrier(MPI_COMM_WORLD);

double t0=MPI_Wtime();
MPI_Request req;
int **recv = new int*[size];
for (int i=0; i<size; i++) recv[i] = new int[N];
int **send = new int*[size];
for (i=0; i<size; i++) send[i] = new int[N];

for (i=rank+1; i<size; i++)
{
	MPI_Isend( send[rank], N, MPI_INT, i, 0, MPI_COMM_WORLD, &req );
	printf("%d:Sending to %d\n", rank, i);
}

//MPI_Irecv( recv[rank], N, MPI_INT, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &req);
if (rank != 0) {
	MPI_Request *reqs = new MPI_Request[rank];
	for (int ll=0; ll<rank; ll++) 
		MPI_Irecv( recv[ll], N, MPI_INT, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &reqs[ll]);
	//reqs[ll]=req;
	int index;
	MPI_Status stats;// = new MPI_Status[rank];
	int r=0;
	for (int j=0; j<rank; j++) {
		int res = MPI_Waitany(rank, reqs, &index, &stats);
		printf("%d:received from %d\n", rank, index);
		if (index >= 0) {
			MPI_Isend( send[rank], N, MPI_INT, index, 0, MPI_COMM_WORLD, &req );
			printf("%d:Sending ANSWER to %d\n", rank, index);
		}
	}
}

MPI_Barrier(MPI_COMM_WORLD);
double t1=MPI_Wtime();

MPI_Finalize();	

if (rank==0) {
	printf("Total time:%f\n", (t1-t0));
	double localr = (2*N*(size-1))/(t1-t0);
	double totalr = (size*N*(size-1))/(t1-t0);
	double avgr = (2*N)/(t1-t0);
	printf("R_LOCAL = %f\n", localr);
	printf("R_TOTAL = %f\n", totalr);
	printf("R_AVG   = %f\n", avgr);
}

}
